/**
 * 1. Daten holen 2. Daten parsen 3. View aufbauen 4. View Funktionalität 5. los
 */

;
(function($) {

	var kbb;
	kbb = this.kbb = {};
	kbb.widgetName = "ScoreCounting";

	
	kbb.editModeSize = 'L';
	kbb.infoModeSize = 'L';
	
	kbb.locale = "en";
	kbb.dataPath = "data/";
	kbb.startElement = 0;
	
	kbb.randomNum = 1;
	kbb.widgetWidth = 420;
	kbb.widgetHeight = 120;
	

	kbb.html = "";

	kbb.animating = false;
	kbb.numDigits = 2;
	kbb.theme = '2';
	kbb.increment = 1;
	kbb.score = 0;
	kbb.startsWith = 0;
	
	kbb.history = new Array();
	
	kbb.incrementArray = [1, 2, 5, 10, 20, 50, 100, 200, 500, 1000];
	
	kbb.themes = ["digital", "fence", "blackboard"];
	
	kbb.editModeFormElements = [ {
		type : 'radiogroup',
		label : 'Skin select',
		name : 'skinSelect',
		items: [{ value: 'digital', title: 'Digital'},
		        { value: 'fence', title: 'Fence'}, 
		        { value: 'blackboard', title: 'Blackboard'}],
		initial : 'fence'
	},  {
		type : 'slider',
		name : 'numDigits',
		label : 'Number of digits',
		sliderMin: 1,
		sliderMax: 7,
		initial: 2
	},  {
		type : 'slider',
		name : 'increment',
		label : 'Increment per click',
		sliderMin: 1,
		sliderMax: kbb.incrementArray.length,
		initial: 1
	}, {
		type : 'input',
		label : 'Start value',
		name : 'startValue',
		initial : '0'
	}, {
		type : 'radiogroup',
		label : 'Up or down',
		name : 'upOrDown',
		items: [{ value: 'up', title: 'Up'}, 
		        { value: 'down', title: 'Down'}],
		initial : 'up'
	}, {
		type : 'okCancel',
		okName : 'saveForm',
		cancelName : 'cancelForm'
	}

	];
	
	kbb.cancelForm = function() {
		
		EM.hideForm();
		
//		var widget = KBBUTIL.getWidgetObject();
//		widget.width = kbb.widgetWidth;
//		widget.height = kbb.widgetHeight;
//KBBUTIL.log("cancelForm "+ kbb.widgetWidth);		
		
		kbb.initFromPersistance();
		
	};
	
	
	kbb.editMode = function() {
		
		KBBUTIL.editModeSize = kbb.editModeSize;
		KBBUTIL.addEditMode(kbb.editModeFormElements);
		KBBUTIL.infoModeSize = kbb.infoModeSize;
		KBBUTIL.addInfoMode();		
	};
	
	
	kbb.initFromPersistance = function() {
	
		KBBUTIL.log("kbb.initFromPersistance");
		
		var numDigits = KBBUTIL.load('numDigits');
		
		numDigits = (numDigits == 'not-found') ? kbb.numDigits : numDigits;

		var theme;
		for(var i=0; i<kbb.themes.length; i++) {
		
			theme = kbb.themes[i];
			$('#display .left').removeClass(theme + "Left");
			$('#display .center').removeClass(theme + "Center");
			$('#display .right').removeClass(theme + "Right");	
			$('#btnWrapper').removeClass(theme);
		}
		
		theme = KBBUTIL.load("skinSelect");
		KBBUTIL.log("current theme "+ theme);
		
		theme = (theme == 'not-found') ? 'fence' : theme; 

		$('#btnWrapper').addClass(theme);
		
		if(theme == 'digital') kbb.theme = '1';
		else if(theme == 'blackboard') kbb.theme = '3';
		else kbb.theme = '2';
		
		$('#display .left').addClass(theme + "Left");
		$('#display .center').addClass(theme + "Center");
		$('#display .right').addClass(theme + "Right");
		
		
		kbb.increment = KBBUTIL.load('increment');
		kbb.increment = (isNaN(kbb.increment)) ? 1 : kbb.increment;
		
		numDigits = (isNaN(numDigits)) ? 2 : numDigits;
		
		KBBUTIL.log("numDigits "+ numDigits);
		
		var singleDigitWidth = 80;
		var boardWidth = 0;
		
		
		$('.digit').addClass("hidden");
		for(var i=1; i<=numDigits; i++) {
			
			$('.digit' + i).removeClass("hidden");
			boardWidth += singleDigitWidth;
		}
		$('#display .center').css('width', boardWidth);

		var widthSides = (theme == 'blackboard') ? 220 : 170;
		
		kbb.widgetWidth = parseInt(boardWidth) + widthSides;
		var widget = KBBUTIL.getWidgetObject();

KBBUTIL.log("initFromPersistance "+ boardWidth + " "+ kbb.widgetWidth);
		
		widget.width = kbb.widgetWidth;
		widget.height = kbb.widgetHeight;
		
		KBBUTIL.log("widget.width "+ widget.width);
		$('body').css('width', kbb.widgetWidth)
			.css('height', 120);
		
		if(kbb.startsWith != KBBUTIL.load('startValue') && KBBUTIL.load('startValue') != 'not-found') {
			
			kbb.score = parseInt(KBBUTIL.load('startValue'));
			kbb.startsWith = KBBUTIL.load('startValue');
//			kbb.setScore();
		}
		
		kbb.setScore();		
	};
	

	

	
	kbb.updateIncrement = function() {

		if(KBBUTIL.load("upOrDown") == 'down') { 		
			kbb.score -= kbb.increment;
			kbb.history.push(kbb.increment*-1);
		} else {
			kbb.score = parseInt(kbb.score) + parseInt(kbb.increment);
			kbb.history.push(kbb.increment);
		}

		kbb.setScore();
	};
	
	
	kbb.setScore = function () {
		
		kbb.score = (kbb.score < 0) ? 0 : kbb.score;
		var s = String(kbb.score);
		var n = 7;
		var i = 0;
		
		while(s.length < 7) {
			
			s = "0" + s;
		}
		
		KBBUTIL.log("kbb.setScore " + s);
		
		
		
		for(i=0; i<7; i++) {
			
			var sub = s.substr(i,1);
			
			KBBUTIL.log("kbb.setScore sub " + sub + " for " + i +" "+ $('.digit' + n).hasClass('hidden'));
			
			/*
			 * too much, tilt XXXXXX */
			if($('.digit' + n).hasClass('hidden') === true && sub != '0') {
				
				$('.digit img').attr('src', 'data/' + kbb.theme +'/X.png');
				break;
			}
			
			$('#digit' + n).attr('src', 'data/' + kbb.theme +'/numbers/' + sub + '.png');
			n--;
		}
		
		var theme = KBBUTIL.load("skinSelect");
		if(theme != 'blackboard')
			kbb.animating = false;
	};
	
	
	kbb.addEvents = function() {

		KBBUTIL.log("kbb.addEvents");

		$('#display').click(function() {

			if(kbb.animating === true) return;
			
			kbb.animating = true;
			
			
			var theme = KBBUTIL.load("skinSelect");
			if(theme == 'blackboard') {
				
				var toLeft = parseInt( kbb.widgetWidth) + 50;
				var msec = 500;
				$('.hand').show().animate({'left': toLeft}, msec, function() {

					$('.hand').hide().css('left', '-100');
					kbb.animating = false;
					kbb.updateIncrement();
				  });
			
				//setTimeout("kbb.updateIncrement()", 200);
				
			} else{
			
				kbb.updateIncrement();
			}
			
			
		});
		
		$('#btnUndo').click(function() {
			
			if(kbb.history.length == 0)
				return;
			
			var latest = kbb.history[kbb.history.length-1];
			
			KBBUTIL.log("kbb.history " + kbb.history);
			KBBUTIL.log("latest "+latest);
			
			kbb.score = parseInt(kbb.score) - parseInt(latest);
			
			KBBUTIL.log("kbb.score "+kbb.score);
			kbb.historyStepBack();
			kbb.setScore();
		});

		
		$('#btnReset').click(function() {
			
			kbb.score = (KBBUTIL.load('startValue') == 'not-found') ? 0 : KBBUTIL.load('startValue');
			kbb.setScore();
		});		
		
		NB.addObserver("dndDropEvent", function(evt) {

			for ( var guid in evt.eventData) {
				
				var chk = NB.getObject(guid);

				if (NB.getHostObject().contains(chk.x, chk.y)) {
				
					KBBUTIL.log("chk.getText() " + chk.getText());
					
					if(chk.getText() === undefined && chk.text === undefined && chk.getCustomProperty('myVal', null) === null)
						return;
					
					val = (chk.text !== undefined) 
						? parseInt(chk.text) 
						: (chk.getText() !== undefined) 
							? parseInt(chk.getText()) 
							: parseInt(chk.getCustomProperty('myVal'));
					
					if(isNaN(val))
						return;
					
					KBBUTIL.log("drop val " + val);
					
					if(KBBUTIL.load("upOrDown") == 'down') { 		
						kbb.score -= val;
						kbb.history.push(val*-1);
					} else {
						kbb.score = parseInt(kbb.score) + parseInt(val);
						kbb.history.push(val);
					}

					chk.deleteObject();
					
					kbb.setScore();
				}
			}


		});
		

		// NEXT AND LAST STEP
		//KBBWIDGETSETUP.localizeText(kbb.locale);
		KBBUTIL.moveToBack();
	};

	kbb.historyStepBack = function() {
		
		var arr = new Array();
		
		for(var i=0; i<kbb.history.length-1; i++) {
			
			arr.push(kbb.history[i]);
		}
		
		kbb.history = arr;
	};
	
	
	kbb.getViewStage = function() {

		KBBUTIL.log("kbb.getViewStage");

//style="display:none"
		var html =  
			'<div id="display">' + 
			
				'<div class="hand" ><img src="data/3/Hand.png" border="0" /></div>' +
			
				'<div class="left"></div>'+
				'<div class="center">' +
				
					'<div class="digit digit7 hidden"><img src="data/' + kbb.theme + '/numbers/0.png" id="digit7" border="0" /></div>' +
					'<div class="digit digit6 hidden"><img src="data/' + kbb.theme + '/numbers/0.png" id="digit6" border="0" /></div>' +
					'<div class="digit digit5 hidden"><img src="data/' + kbb.theme + '/numbers/0.png" id="digit5" border="0" /></div>' +					
					'<div class="digit digit4 hidden"><img src="data/' + kbb.theme + '/numbers/0.png" id="digit4" border="0" /></div>' +
					'<div class="digit digit3 hidden"><img src="data/' + kbb.theme + '/numbers/0.png" id="digit3" border="0" /></div>' +
					'<div class="digit digit2"><img src="data/' + kbb.theme + '/numbers/0.png" id="digit2" border="0" /></div>' +
					'<div class="digit digit1"><img src="data/' + kbb.theme + '/numbers/0.png" id="digit1" border="0" /></div>' +
					'<div class="clearer"></div>'+
					
				'</div>'+
				'<div class="right"></div>'+
				'<div class="clearer"></div>'+
				
			'</div>' + 
			'<div id="btnWrapper" class="fence">' + 
			'<div class="btnx" id="btnUndo"><img src="data/spacer.png" border="0" /></div>' +
			'<div class="btnx" id="btnReset"><img src="data/spacer.png" border="0" /></div>' +
			'</div>';


		return html;
	};


	kbb.createView = function() {

		KBBUTIL.log("kbb.createView");

		kbb.html = '<section class="container">' + 
				kbb.getViewStage() +
				'</section>';
		kbb.element.html(kbb.html).removeClass("preloader");

		kbb.initFromPersistance();
		kbb.editMode();
		
		// NEXT STEP
		kbb.addEvents();
	};

	
	$.fn.startUP = function(locale) {

		kbb.locale = locale;
		kbb.element = $(this);
		
		// NEXT STEP
		kbb.createView();
		NB.localization.translateHtmlElements();
	};


})(jQuery);


$('#widgetContainer').startUP(locale);